clc, clear all

global BD

disp('Flash P Beta rigoroso')
disp(' ')
disp('A carga deve ser dada num vetor linha onde os componentes sao:')
disp('1-Metano, 2-Etano, 3-Propano, 4-nButano, 5-nPentano');
disp('  ')

%especificacoes
z=input('Entre com a composiao da carga:  ');
P=input('Entre com a Pressao no tambor de flash(atm):  ');
BETA=input('Entre com a fraao vaporizada (beta):  ');


% Dados para os componentes:
BD=struct( ...
    'ID', ['CH4  '      ;'C2H6 ';   'C3H8 ';    'C4H10';    'C5H12'],...
    'MM', [16;          30;         44;         58;         72],...
    'Tc', [190.6;       305.4;      369.8;      425.2;      469.6],...
    'Pc', [45.4;        48.2;       41.9;       37.5;       33.3],...
    'w',  [.007;        .041;       .145;       .195;       0.251],...
    'Teb',[111.6;       184.6;      231.1;      272.7;      310],...
    'Zc', [0.228;       0.285;      0.281;      0.274;      0.262],...
    'Vc', [99;          148;        203;        255;        304],...
    'Vl', [52;          68;         84;         101.4;      116.1],...
    'dd', [5.68;        6.05;       6.4;        6.634;      7.02],...
    'A',  [5.14135;     5.383994;   5.353418;   5.741624;   5.853654],...
    'B',  [1742.638;    2847.921;   3371.084;   4126.385;   4598.287],...
    'C',  [452.974;     434.898;    414.488;    409.5179;   394.4148]);





%Estimativas (mistura ideal)

nc=length(z);   T0=310;    T1=1.05*T0;   T=T0;   erro1=1;   erromax=0.001;   n=0;
               
while erro1>=erromax
    
    %calculo de psat, K, X, Y
        
		for j=1:nc
		
            TF=1.8*T-459.67;
		    PSAT(j)=BD.Pc(j)*exp(BD.A(j)-BD.B(j)/(BD.C(j)+TF));
            K(j)=PSAT(j)/P;           
            x(j)=z(j)/(1-BETA+BETA*K(j));
            y(j)=K(j)*x(j);
            
		end
          
    %calculo da eq. do flash
         
		for j=1:nc
            
            F(j)=(K(j)-1)*z(j)/(1-BETA+BETA*K(j));   
		end 
            Flash1=sum(F);
      
        if n==0
         
            n=n+1;     T=T1;      Flash0=Flash1;              
         
        else
         
            T2=T1-Flash1*(T1-T0)/(Flash1-Flash0);
            erro1=abs(T2-T1);
            n=n+1;     Flash0=Flash1;      T0=T1;      T1=T2;      T=T1;
         
        end

end 

disp(' '),
disp('Temperatura do flash estimada'),T
disp('Composiao da fraao liquida estimada'),x
disp('Composiao da fraao vaporizada estimada'),y







%Calculo da Temp, X e Y (mistura real)

erro1=1;        erro2=1;        erromax=0.001;      T1=1.1*T;       m=0;            n=0;
		
while erro2>=erromax
        
		while erro1>=erromax
                   
			%calculo de psat,gama, fug
				
                for j=1:nc
				
					TF=1.8*T-459.67;
                    PSAT(j)=BD.Pc(j)*exp(BD.A(j)-BD.B(j)/(BD.C(j)+TF));
                    [FUG]=FUGAC(P,T,y);
                    [GAMA]=ATIVIDADE(T,P,x);
                                       	                    
                end          
           
            %calculo de K, X, Y
			
			 	for j=1:nc
                    
                    K(j)=PSAT(j)*GAMA(j)/(P*FUG(j));           
                    XX(j)=z(j)/(1-BETA+BETA*K(j));
                    YY(j)=K(j)*XX(j);
                    
               	end
                
            %normalizaao
            
            XXX=sum(XX);    YYY=sum(YY);
            
                for j=1:nc
                    X(j)=XX(j)/XXX;
                    Y(j)=YY(j)/YYY;
                end
                
            erro1=abs(X-x)+abs(Y-y);    erro1=sum(erro1);   x=X;    y=Y;    m=m+1;
            
        end
            
     %calculo da eq. do flash
     
    for j=1:nc
        
        F(j)=(K(j)-1)*z(j)/(1-BETA+BETA*K(j));   
	end 
    
        Flash1=sum(F);
  
    if n==0
     
        n=n+1;     T=T1;      Flash0=Flash1;    erro1=1.1*erromax;          
     
    else
     
        T2=T1-Flash1*(T1-T0)/(Flash1-Flash0);
        erro2=abs(T2-T1);
        n=n+1;     Flash0=Flash1;      T0=T1;      T1=T2;      T=T1;    erro1=1.1*erromax; 
     
    end
	
end 

disp(' '),
disp('Temperatura do flash'),T
disp('Composiao da fraao liquida'),x
disp('Composiao da fraao vaporizada'),y

           